/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package xml;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;
import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

class ProductoUsuario {

    private String inRoute;
    private String outRoute;

    private static final String PRODUCT_IDENTIFIER = "XX";
    private static final String USER_IDENTIFIER = "OO";

    public String getInRoute() {
        return inRoute;
    }

    public void setInRoute(String inRoute) {
        this.inRoute = inRoute;
    }

    public String getOutRoute() {
        return outRoute;
    }

    public void setOutRoute(String outRoute) {
        this.outRoute = outRoute;
    }

    private void processProduct(String line, XMLStreamWriter writer) throws XMLStreamException {

        String id = PRODUCT_IDENTIFIER;
        String code = line.substring(3,20);
        String descripcion = line.substring(20);

        writer.writeStartElement("producto");
        writer.writeStartElement("identificador");
        writer.writeCharacters(id);
        writer.writeEndElement();
        writer.writeStartElement("codigo");
        writer.writeCharacters(code);
        writer.writeEndElement();
        writer.writeStartElement("descripcion");
        writer.writeCharacters(descripcion);
        writer.writeEndElement();
        writer.writeEndElement();

    }

    private void processUser(String line, XMLStreamWriter writer) throws XMLStreamException {

        String id = USER_IDENTIFIER;
        String code = line.substring(2,5);
        String descripcion = line.substring(5);

        writer.writeStartElement("usuario");
        writer.writeStartElement("identificador");
        writer.writeCharacters(id);
        writer.writeEndElement();
        writer.writeStartElement("codigo");
        writer.writeCharacters(code);
        writer.writeEndElement();
        writer.writeStartElement("descripcion");
        writer.writeCharacters(descripcion);
        writer.writeEndElement();
        writer.writeEndElement();

    }

    public void processFile() throws Exception {

        if (null == this.inRoute || null == this.outRoute) {
            throw new Exception("Are you crazy?");
        }

        FileInputStream inputStream = null;
        Scanner sc = null;
        XMLOutputFactory factory = null;
        XMLStreamWriter writer = null;

        try {

            factory = XMLOutputFactory.newInstance();
            writer = factory.createXMLStreamWriter(new FileWriter(this.outRoute));

            inputStream = new FileInputStream(this.inRoute);
            sc = new Scanner(inputStream, "UTF-8");

            writer.writeStartDocument();

            while (sc.hasNextLine()) {

                String line = sc.nextLine();

                if(line.startsWith(PRODUCT_IDENTIFIER)) {
                    this.processProduct(line, writer);
                }else  if(line.startsWith(USER_IDENTIFIER)) {
                    this.processUser(line, writer);
                }

            }

            writer.writeEndDocument();

            writer.flush();
            writer.close();

            // note that Scanner suppresses exceptions
            if (null != sc.ioException()) {
                throw sc.ioException();
            }

        } finally {
            if (null != inputStream) {
                inputStream.close();
            }
            if (null != sc) {
                sc.close();
            }
        }


    }

}

/**
 *
 * @author Andres Mella
 */
public class Main {

    public static void main(String[] args) throws Exception {

        ProductoUsuario pu = new ProductoUsuario();
        pu.setInRoute("C:\\file.txt");
        pu.setOutRoute("C:\\salida.xml");
        pu.processFile();
    }

}
